Index: /mods/mod_amazon/Psr/Log/LogLevel.php
===================================================================
--- /mods/mod_amazon/Psr/Log/LogLevel.php	(revision 7756)
+++ /mods/mod_amazon/Psr/Log/LogLevel.php	(revision 7756)
@@ -0,0 +1,18 @@
+<?php
+
+namespace Psr\Log;
+
+/**
+ * Describes log levels.
+ */
+class LogLevel
+{
+    const EMERGENCY = 'emergency';
+    const ALERT     = 'alert';
+    const CRITICAL  = 'critical';
+    const ERROR     = 'error';
+    const WARNING   = 'warning';
+    const NOTICE    = 'notice';
+    const INFO      = 'info';
+    const DEBUG     = 'debug';
+}
Index: /mods/mod_amazon/Psr/Log/LoggerAwareInterface.php
===================================================================
--- /mods/mod_amazon/Psr/Log/LoggerAwareInterface.php	(revision 7756)
+++ /mods/mod_amazon/Psr/Log/LoggerAwareInterface.php	(revision 7756)
@@ -0,0 +1,18 @@
+<?php
+
+namespace Psr\Log;
+
+/**
+ * Describes a logger-aware instance.
+ */
+interface LoggerAwareInterface
+{
+    /**
+     * Sets a logger instance on the object.
+     *
+     * @param LoggerInterface $logger
+     *
+     * @return null
+     */
+    public function setLogger(LoggerInterface $logger);
+}
Index: /mods/mod_amazon/Psr/Log/LoggerAwareTrait.php
===================================================================
--- /mods/mod_amazon/Psr/Log/LoggerAwareTrait.php	(revision 7756)
+++ /mods/mod_amazon/Psr/Log/LoggerAwareTrait.php	(revision 7756)
@@ -0,0 +1,26 @@
+<?php
+
+namespace Psr\Log;
+
+/**
+ * Basic Implementation of LoggerAwareInterface.
+ */
+trait LoggerAwareTrait
+{
+    /**
+     * The logger instance.
+     *
+     * @var LoggerInterface
+     */
+    protected $logger;
+
+    /**
+     * Sets a logger.
+     *
+     * @param LoggerInterface $logger
+     */
+    public function setLogger(LoggerInterface $logger)
+    {
+        $this->logger = $logger;
+    }
+}
Index: /mods/mod_amazon/Psr/Log/LoggerInterface.php
===================================================================
--- /mods/mod_amazon/Psr/Log/LoggerInterface.php	(revision 7756)
+++ /mods/mod_amazon/Psr/Log/LoggerInterface.php	(revision 7756)
@@ -0,0 +1,123 @@
+<?php
+
+namespace Psr\Log;
+
+/**
+ * Describes a logger instance.
+ *
+ * The message MUST be a string or object implementing __toString().
+ *
+ * The message MAY contain placeholders in the form: {foo} where foo
+ * will be replaced by the context data in key "foo".
+ *
+ * The context array can contain arbitrary data. The only assumption that
+ * can be made by implementors is that if an Exception instance is given
+ * to produce a stack trace, it MUST be in a key named "exception".
+ *
+ * See https://github.com/php-fig/fig-standards/blob/master/accepted/PSR-3-logger-interface.md
+ * for the full interface specification.
+ */
+interface LoggerInterface
+{
+    /**
+     * System is unusable.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function emergency($message, array $context = array());
+
+    /**
+     * Action must be taken immediately.
+     *
+     * Example: Entire website down, database unavailable, etc. This should
+     * trigger the SMS alerts and wake you up.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function alert($message, array $context = array());
+
+    /**
+     * Critical conditions.
+     *
+     * Example: Application component unavailable, unexpected exception.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function critical($message, array $context = array());
+
+    /**
+     * Runtime errors that do not require immediate action but should typically
+     * be logged and monitored.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function error($message, array $context = array());
+
+    /**
+     * Exceptional occurrences that are not errors.
+     *
+     * Example: Use of deprecated APIs, poor use of an API, undesirable things
+     * that are not necessarily wrong.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function warning($message, array $context = array());
+
+    /**
+     * Normal but significant events.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function notice($message, array $context = array());
+
+    /**
+     * Interesting events.
+     *
+     * Example: User logs in, SQL logs.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function info($message, array $context = array());
+
+    /**
+     * Detailed debug information.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function debug($message, array $context = array());
+
+    /**
+     * Logs with an arbitrary level.
+     *
+     * @param mixed  $level
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function log($level, $message, array $context = array());
+}
Index: /mods/mod_amazon/Psr/Log/LoggerTrait.php
===================================================================
--- /mods/mod_amazon/Psr/Log/LoggerTrait.php	(revision 7756)
+++ /mods/mod_amazon/Psr/Log/LoggerTrait.php	(revision 7756)
@@ -0,0 +1,140 @@
+<?php
+
+namespace Psr\Log;
+
+/**
+ * This is a simple Logger trait that classes unable to extend AbstractLogger
+ * (because they extend another class, etc) can include.
+ *
+ * It simply delegates all log-level-specific methods to the `log` method to
+ * reduce boilerplate code that a simple Logger that does the same thing with
+ * messages regardless of the error level has to implement.
+ */
+trait LoggerTrait
+{
+    /**
+     * System is unusable.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function emergency($message, array $context = array())
+    {
+        $this->log(LogLevel::EMERGENCY, $message, $context);
+    }
+
+    /**
+     * Action must be taken immediately.
+     *
+     * Example: Entire website down, database unavailable, etc. This should
+     * trigger the SMS alerts and wake you up.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function alert($message, array $context = array())
+    {
+        $this->log(LogLevel::ALERT, $message, $context);
+    }
+
+    /**
+     * Critical conditions.
+     *
+     * Example: Application component unavailable, unexpected exception.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function critical($message, array $context = array())
+    {
+        $this->log(LogLevel::CRITICAL, $message, $context);
+    }
+
+    /**
+     * Runtime errors that do not require immediate action but should typically
+     * be logged and monitored.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function error($message, array $context = array())
+    {
+        $this->log(LogLevel::ERROR, $message, $context);
+    }
+
+    /**
+     * Exceptional occurrences that are not errors.
+     *
+     * Example: Use of deprecated APIs, poor use of an API, undesirable things
+     * that are not necessarily wrong.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function warning($message, array $context = array())
+    {
+        $this->log(LogLevel::WARNING, $message, $context);
+    }
+
+    /**
+     * Normal but significant events.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function notice($message, array $context = array())
+    {
+        $this->log(LogLevel::NOTICE, $message, $context);
+    }
+
+    /**
+     * Interesting events.
+     *
+     * Example: User logs in, SQL logs.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function info($message, array $context = array())
+    {
+        $this->log(LogLevel::INFO, $message, $context);
+    }
+
+    /**
+     * Detailed debug information.
+     *
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function debug($message, array $context = array())
+    {
+        $this->log(LogLevel::DEBUG, $message, $context);
+    }
+
+    /**
+     * Logs with an arbitrary level.
+     *
+     * @param mixed  $level
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    abstract public function log($level, $message, array $context = array());
+}
Index: /mods/mod_amazon/Psr/Log/NullLogger.php
===================================================================
--- /mods/mod_amazon/Psr/Log/NullLogger.php	(revision 7756)
+++ /mods/mod_amazon/Psr/Log/NullLogger.php	(revision 7756)
@@ -0,0 +1,28 @@
+<?php
+
+namespace Psr\Log;
+
+/**
+ * This Logger can be used to avoid conditional log calls.
+ *
+ * Logging should always be optional, and if no logger is provided to your
+ * library creating a NullLogger instance to have something to throw logs at
+ * is a good way to avoid littering your code with `if ($this->logger) { }`
+ * blocks.
+ */
+class NullLogger extends AbstractLogger
+{
+    /**
+     * Logs with an arbitrary level.
+     *
+     * @param mixed  $level
+     * @param string $message
+     * @param array  $context
+     *
+     * @return null
+     */
+    public function log($level, $message, array $context = array())
+    {
+        // noop
+    }
+}
Index: /mods/mod_amazon/Psr/Log/Test/LoggerInterfaceTest.php
===================================================================
--- /mods/mod_amazon/Psr/Log/Test/LoggerInterfaceTest.php	(revision 7756)
+++ /mods/mod_amazon/Psr/Log/Test/LoggerInterfaceTest.php	(revision 7756)
@@ -0,0 +1,133 @@
+<?php
+
+namespace Psr\Log\Test;
+
+use Psr\Log\LoggerInterface;
+use Psr\Log\LogLevel;
+
+/**
+ * Provides a base test class for ensuring compliance with the LoggerInterface.
+ *
+ * Implementors can extend the class and implement abstract methods to run this
+ * as part of their test suite.
+ */
+abstract class LoggerInterfaceTest extends \PHPUnit_Framework_TestCase
+{
+    /**
+     * @return LoggerInterface
+     */
+    abstract public function getLogger();
+
+    /**
+     * This must return the log messages in order.
+     *
+     * The simple formatting of the messages is: "<LOG LEVEL> <MESSAGE>".
+     *
+     * Example ->error('Foo') would yield "error Foo".
+     *
+     * @return string[]
+     */
+    abstract public function getLogs();
+
+    public function testImplements()
+    {
+        $this->assertInstanceOf('Psr\Log\LoggerInterface', $this->getLogger());
+    }
+
+    /**
+     * @dataProvider provideLevelsAndMessages
+     */
+    public function testLogsAtAllLevels($level, $message)
+    {
+        $logger = $this->getLogger();
+        $logger->{$level}($message, array('user' => 'Bob'));
+        $logger->log($level, $message, array('user' => 'Bob'));
+
+        $expected = array(
+            $level.' message of level '.$level.' with context: Bob',
+            $level.' message of level '.$level.' with context: Bob',
+        );
+        $this->assertEquals($expected, $this->getLogs());
+    }
+
+    public function provideLevelsAndMessages()
+    {
+        return array(
+            LogLevel::EMERGENCY => array(LogLevel::EMERGENCY, 'message of level emergency with context: {user}'),
+            LogLevel::ALERT => array(LogLevel::ALERT, 'message of level alert with context: {user}'),
+            LogLevel::CRITICAL => array(LogLevel::CRITICAL, 'message of level critical with context: {user}'),
+            LogLevel::ERROR => array(LogLevel::ERROR, 'message of level error with context: {user}'),
+            LogLevel::WARNING => array(LogLevel::WARNING, 'message of level warning with context: {user}'),
+            LogLevel::NOTICE => array(LogLevel::NOTICE, 'message of level notice with context: {user}'),
+            LogLevel::INFO => array(LogLevel::INFO, 'message of level info with context: {user}'),
+            LogLevel::DEBUG => array(LogLevel::DEBUG, 'message of level debug with context: {user}'),
+        );
+    }
+
+    /**
+     * @expectedException \Psr\Log\InvalidArgumentException
+     */
+    public function testThrowsOnInvalidLevel()
+    {
+        $logger = $this->getLogger();
+        $logger->log('invalid level', 'Foo');
+    }
+
+    public function testContextReplacement()
+    {
+        $logger = $this->getLogger();
+        $logger->info('{Message {nothing} {user} {foo.bar} a}', array('user' => 'Bob', 'foo.bar' => 'Bar'));
+
+        $expected = array('info {Message {nothing} Bob Bar a}');
+        $this->assertEquals($expected, $this->getLogs());
+    }
+
+    public function testObjectCastToString()
+    {
+        $dummy = $this->getMock('Psr\Log\Test\DummyTest', array('__toString'));
+        $dummy->expects($this->once())
+            ->method('__toString')
+            ->will($this->returnValue('DUMMY'));
+
+        $this->getLogger()->warning($dummy);
+
+        $expected = array('warning DUMMY');
+        $this->assertEquals($expected, $this->getLogs());
+    }
+
+    public function testContextCanContainAnything()
+    {
+        $context = array(
+            'bool' => true,
+            'null' => null,
+            'string' => 'Foo',
+            'int' => 0,
+            'float' => 0.5,
+            'nested' => array('with object' => new DummyTest),
+            'object' => new \DateTime,
+            'resource' => fopen('php://memory', 'r'),
+        );
+
+        $this->getLogger()->warning('Crazy context data', $context);
+
+        $expected = array('warning Crazy context data');
+        $this->assertEquals($expected, $this->getLogs());
+    }
+
+    public function testContextExceptionKeyCanBeExceptionOrOtherValues()
+    {
+        $logger = $this->getLogger();
+        $logger->warning('Random message', array('exception' => 'oops'));
+        $logger->critical('Uncaught Exception!', array('exception' => new \LogicException('Fail')));
+
+        $expected = array(
+            'warning Random message',
+            'critical Uncaught Exception!'
+        );
+        $this->assertEquals($expected, $this->getLogs());
+    }
+}
+
+class DummyTest
+{
+}
Index: /mods/wpsg_mod_amazon.class.php
===================================================================
--- /mods/wpsg_mod_amazon.class.php	(revision 7755)
+++ /mods/wpsg_mod_amazon.class.php	(revision 7756)
@@ -45,8 +45,7 @@
         } // public function install()
 
-        public function settings_edit()
-        {
-
-            $this->shop->view['ipnURL'] = $this->shop->getUrl(wpsg_ShopController::URL_BASKET, 'wpsg_mod_amazon', 'ipn');
+        public function settings_edit() {
+
+            $this->shop->view['ipnURL'] = $this->shop->getUrl(wpsg_ShopController::URL_BASKET, 'wpsg_mod_amazon', 'ipn', [], true);
             $this->shop->view['jsOrigin'] = preg_replace('/^http:\/\//i', 'https://', $this->shop->get_option('siteurl'));
 
@@ -54,4 +53,19 @@
 
         } // public function settings_edit()
+
+        public function order_view_afterpayment(&$order_id) {
+
+            $oOrder = wpsg_order::getInstance($order_id);
+
+            if ($oOrder->getPaymentID() == $this->id) {
+
+                $this->shop->view['oOrder'] = $oOrder;
+
+                $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_amazon/order_view_afterpayment.phtml');
+
+            }
+
+
+        }
 
         public function settings_save()
@@ -98,11 +112,9 @@
         } // public function basket_inner_prebutton(&$basket_view)
 
-        public function setOrderStatus($order_id, $status_id, $inform)
-        {
-
-            $oOrder = wpsg_order::getInstance($order_id);
-
-            if ($oOrder->getPaymentID() == $this->id && in_array($status_id, array(wpsg_ShopController::STATUS_STORNIERT, wpsg_ShopController::STATUS_ZURUECKGEZAHLT)))
-            {
+        public function setOrderStatus($order_id, $status_id, $inform) {
+
+            $oOrder = wpsg_order::getInstance($order_id);
+
+            if ($oOrder->getPaymentID() == $this->id && in_array($status_id, array(wpsg_ShopController::STATUS_STORNIERT, wpsg_ShopController::STATUS_ZURUECKGEZAHLT))) {
 
                 $capture_id = $oOrder->getMeta('amazon_capture_id');
@@ -169,5 +181,8 @@
             if ($oOrder->getToPay() <= 0 || $oOrder->getPaymentID() != $this->id) return;
 
-            if (wpsg_isSizedString($oOrder->getMeta('amazon_order_reference_id')) && !wpsg_isSizedString($oOrder->getMeta('amazon_order_done')))
+            $amazon_order_reference_id = $oOrder->getMeta('amazon_order_reference_id');
+            $amazon_order_done = $oOrder->getMeta('amazon_order_done');
+
+            if (wpsg_isSizedString($amazon_order_reference_id) && !wpsg_isSizedString($amazon_order_done))
             {
 
@@ -198,6 +213,5 @@
                 }
 
-            }
-            else if (wpsg_isSizedString($oOrder->getMeta('amazon_order_done')))
+            } else if (wpsg_isSizedString($amazon_order_done))
             {
 
@@ -207,5 +221,5 @@
             }
 
-            if (wpsg_isSizedString($oOrder->getMeta('amazon_order_reference_id')))
+            if (wpsg_isSizedString($amazon_order_reference_id))
             {
 
@@ -429,23 +443,23 @@
             require_once WPSG_PATH_MOD.'mod_amazon/PayWithAmazon/IpnHandler.php';
 
-            $headers = $_SERVER; // getallheaders();
+            $headers = getallheaders();
             $body = file_get_contents('php://input');
 
-            $ipnHandler = new \PayWithAmazon\IpnHandler($headers, $body);
+            $ipnHandler = new \AmazonPay\IpnHandler($headers, $body);
             $ipnData = $ipnHandler->toArray();
 
-            if (wpsg_isSizedArray($ipnData) && wpsg_isSizedString($ipnData['NotificationType'], 'PaymentCapture'))
-            {
+            if (wpsg_isSizedArray($ipnData) && wpsg_isSizedString($ipnData['NotificationType'], 'PaymentCapture')) {
 
                 $order_id = $ipnData['CaptureDetails']['CaptureReferenceId'];
                 $oOrder = wpsg_order::getInstance($order_id);
 
-                if (wpsg_isSizedInt($this->shop->get_option('wpsg_debugModus'))) $oOrder->log('Amazon:notification:PaymentCapture', print_r($ipnData, 1));
-
-                if ($this->shop->setPayMent($order_id, $ipnData['CaptureDetails']['CaptureAmount']['Amount']) && wpsg_isSizedString($ipnData['CaptureDetails']['CaptureStatus']['State'], 'Completed'))
-                {
+                $oOrder->addLogEntry(
+                    __('Amazon IPN Eingang', 'wpsg'),
+                    print_r($ipnData, true).print_r(getallheaders(), true)
+                );
+
+                if ($this->shop->setPayMent($order_id, $ipnData['CaptureDetails']['CaptureAmount']['Amount']) && wpsg_isSizedString($ipnData['CaptureDetails']['CaptureStatus']['State'], 'Completed')) {
 
                     $oOrder->setMeta('amazon_capture_id', $ipnData['CaptureDetails']['AmazonCaptureId']);
-
                     $this->shop->setOrderStatus($order_id, 100, true);
 
@@ -463,20 +477,17 @@
         } // public function logoutRedirect()
 
-        public function returnRedirect()
-        {
-
-            if (wpsg_isSizedInt($_REQUEST['order_id']) && wpsg_isSizedString($_REQUEST['wpsg_done']))
-            {
+        public function returnRedirect() {
+
+            if (wpsg_isSizedInt($_REQUEST['order_id']) && wpsg_isSizedString($_REQUEST['wpsg_done'])) {
 
                 $_REQUEST['order_id'] = wpsg_sinput("key", $_REQUEST['order_id']);
 
-                if (wpsg_isSizedString($_REQUEST['amazon']['OrderReference']))
-                {
-
-                    $hash = preg_replace('/(\+)|(\=)/', 'A', base64_encode(md5('wpShopGermany'.$_REQUEST['order_id'], $this->shop->get_option("wpsg_salt"))));
-
-                    if ($hash != $_REQUEST['wpsg_done']) die(__('Aufrufsfehler!!', 'wpsg'));
+                if (wpsg_isSizedString($_REQUEST['amazon']['OrderReference'])) {
 
                     $oOrder = wpsg_order::getInstance($_REQUEST['order_id']);
+
+                    $hash = md5($oOrder->__get('secret').$oOrder->getId().$oOrder->__get('secret'));
+                    if (!hash_equals($hash, rawurldecode($_REQUEST['wpsg_done']))) die(__('Aufrufsfehler!!', 'wpsg'));
+
                     $oOrder->setMeta('amazon_order_reference_id', $_REQUEST['amazon']['OrderReference']);
 
@@ -540,5 +551,5 @@
 
             $oOrder = wpsg_order::getInstance($order_id);
-            $client = new PayWithAmazon\Client($this->getAPIConfig());
+            $client = new AmazonPay\Client($this->getAPIConfig());
 
             $oResponse = $client->confirmOrderReference(array(
@@ -547,5 +558,5 @@
             ));
 
-            if (wpsg_isSizedInt($this->shop->get_option('wpsg_debugModus'))) $oOrder->log('Amazon:confirmOrderReference', print_r($oResponse->toArray(), 1));
+            if (wpsg_isSizedInt($this->shop->get_option('wpsg_debugMowpdus'))) $oOrder->log('Amazon:confirmOrderReference', print_r($oResponse->toArray(), 1));
 
             return $oResponse->toArray();
@@ -559,5 +570,5 @@
 
             $oOrder = wpsg_order::getInstance($order_id);
-            $client = new PayWithAmazon\Client($this->getAPIConfig());
+            $client = new AmazonPay\Client($this->getAPIConfig());
 
             $oResponse = $client->getOrderReferenceDetails(array(
@@ -578,5 +589,5 @@
 
             $oOrder = wpsg_order::getInstance($order_id);
-            $client = new PayWithAmazon\Client($this->getAPIConfig());
+            $client = new AmazonPay\Client($this->getAPIConfig());
 
             $oResponse = $client->setOrderReferenceDetails(array(
@@ -601,5 +612,5 @@
 
             $oOrder = wpsg_order::getInstance($order_id);
-            $client = new PayWithAmazon\Client($this->getAPIConfig());
+            $client = new AmazonPay\Client($this->getAPIConfig());
 
             $oResponse = $client->authorize(array(
@@ -629,5 +640,5 @@
 
             $oOrder = wpsg_order::getInstance($order_id);
-            $client = new PayWithAmazon\Client($this->getAPIConfig());
+            $client = new AmazonPay\Client($this->getAPIConfig());
 
             $oResponse = $client->closeOrderReference(array(
@@ -649,5 +660,5 @@
 
             $oOrder = wpsg_order::getInstance($order_id);
-            $client = new PayWithAmazon\Client($this->getAPIConfig());
+            $client = new AmazonPay\Client($this->getAPIConfig());
 
             $oResponse = $client->cancelOrderReference(array(
@@ -661,11 +672,10 @@
         } // private function api_cancelPayment($order_id)
 
-        private function api_refund($order_id)
-        {
+        private function api_refund($order_id) {
 
             require_once WPSG_PATH_MOD.'mod_amazon/PayWithAmazon/Client.php';
 
             $oOrder = wpsg_order::getInstance($order_id);
-            $client = new PayWithAmazon\Client($this->getAPIConfig());
+            $client = new AmazonPay\Client($this->getAPIConfig());
 
             $oResponse = $client->refund(array(
@@ -679,6 +689,7 @@
             $arReturn = $oResponse->toArray();
 
-            if (wpsg_isSizedString($arReturn['RefundResult']['RefundDetails']['AmazonRefundId']))
-            {
+            $oOrder->addLogEntry('Amazon Storno', print_r($arReturn, true));
+
+            if (wpsg_isSizedString($arReturn['RefundResult']['RefundDetails']['AmazonRefundId'])) {
 
                 $oOrder->setMeta('amazon_refund_id', $arReturn['RefundResult']['RefundDetails']['AmazonRefundId']);
Index: /mods/wpsg_mod_autodebit.class.php
===================================================================
--- /mods/wpsg_mod_autodebit.class.php	(revision 7755)
+++ /mods/wpsg_mod_autodebit.class.php	(revision 7756)
@@ -475,13 +475,13 @@
 			
 			$iban = str_replace(' ', '', $iban);
-			$iban1 = substr($iban, 4).strval(ord($iban{0}) - 55).strval(ord($iban{1}) - 55). substr($iban, 2, 2);
+			$iban1 = substr($iban, 4).strval(ord($iban[0]) - 55).strval(ord($iban[1]) - 55). substr($iban, 2, 2);
 		
 			for ($i = 0; $i < strlen($iban1); $i++) 
 			{
 				
-				if(ord($iban1{$i}) > 64 && ord($iban1{$i}) < 91) 
+				if(ord($iban1[$i]) > 64 && ord($iban1[$i]) < 91)
 				{
 					
-					$iban1 = substr($iban1, 0, $i).strval(ord($iban1{$i}) - 55).substr($iban1, $i + 1);
+					$iban1 = substr($iban1, 0, $i).strval(ord($iban1[$i]) - 55).substr($iban1, $i + 1);
 					
 				}
Index: /mods/wpsg_mod_crefopay.class.php
===================================================================
--- /mods/wpsg_mod_crefopay.class.php	(revision 7755)
+++ /mods/wpsg_mod_crefopay.class.php	(revision 7756)
@@ -393,7 +393,5 @@
 			if (wpsg_isSizedString($_REQUEST['wpsg_plugin'], 'wpsg_mod_crefopay'))
 			{
-				
-				//mail("daniel@maennchen1.de", "CREFOTEST ".$_REQUEST['return'], print_r($_REQUEST, 1));
-				
+
 				// TemporÃ€r den Request korrigieren
 				// Anfrage URL: http://dev.wpshopgermany.de/warenkorb/?wpsg_plugin=wpsg_mod_crefopay&return=redirect?merchantID=2&...
Index: /mods/wpsg_mod_micropayment_paywindow.class.php
===================================================================
--- /mods/wpsg_mod_micropayment_paywindow.class.php	(revision 7755)
+++ /mods/wpsg_mod_micropayment_paywindow.class.php	(revision 7756)
@@ -85,4 +85,10 @@
 			
 		} // public function __construct()
+
+        public function install() {
+
+            $this->shop->checkDefault('wpsg_mod_micropayment_autorun', '1');
+
+        }
 
 		public function settings_edit() {
Index: /mods/wpsg_mod_willcollect.class.php
===================================================================
--- /mods/wpsg_mod_willcollect.class.php	(revision 7755)
+++ /mods/wpsg_mod_willcollect.class.php	(revision 7756)
@@ -304,3 +304,2 @@
 	} // class wpsg_mod_willcollect extends wpsg_mod_basic
 
-?>
Index: /views/mods/mod_amazon/order_done.phtml
===================================================================
--- /views/mods/mod_amazon/order_done.phtml	(revision 7755)
+++ /views/mods/mod_amazon/order_done.phtml	(revision 7756)
@@ -21,5 +21,5 @@
 <div id="PayWithAmazon" style="<?php echo (($this->view['wpsg_mod_amazon']['state'] === wpsg_mod_amazon::ORDER_DONE_GO)?'display:none':''); ?>"></div>
 
-<script type="text/javascript">/* <![CDATA[ */
+<script type="text/javascript">
  
 	var authRequest; 
@@ -53,6 +53,5 @@
 	var autoRun = setInterval(function(){ 
 
-		if (jQuery('#PayWithAmazon img').length > 0)
-		{
+		if (jQuery('#PayWithAmazon img').length > 0) {
 
 			//setTimeout(function(){ jQuery('#PayWithAmazon img').click(); }, 1000);
@@ -63,5 +62,5 @@
 	}, 100);
 
-/* ]]> */</script>
+</script>
 	
 <?php } ?>
@@ -75,5 +74,5 @@
 	<input type="hidden" name="amazon[OrderReference]" id="wpsg_mod_amazon_OrderReference" value="" />
 	
-	<div id="walletWidgetDiv"></div>
+	<div id="walletWidgetDiv"></div><br />
 	
 	<input type="submit" class="wpsg_button" name="submit" value="<?php echo __('Zahlung durchfÃŒhren', 'wpsg'); ?>" id="wpsg_mod_amazon_doPayment" style="display:none;" />
@@ -82,6 +81,8 @@
 </form>
 
-<script type="text/javascript">/* <![CDATA[ */
-                                            
+<script>
+
+    jQuery('#walletWidgetDiv').show();
+
 	new OffAmazonPayments.Widgets.Wallet( {
 
@@ -118,4 +119,4 @@
 	} ).bind("walletWidgetDiv");
 	    	
-/* ]]> */</script>
+</script>
 <?php } ?>
Index: /views/mods/mod_amazon/order_view_afterpayment.phtml
===================================================================
--- /views/mods/mod_amazon/order_view_afterpayment.phtml	(revision 7756)
+++ /views/mods/mod_amazon/order_view_afterpayment.phtml	(revision 7756)
@@ -0,0 +1,24 @@
+<?php
+
+	/**
+	 * Template fÃŒr die Integration der Amazon Zahlungsart in die Bestellverwaltung
+	 */
+
+	/** @var wpsg_order $oOrder */
+	$oOrder = $this->view['oOrder'];
+
+	$amazon_capture_id = $oOrder->getMeta('amazon_capture_id');
+	$amazon_refund_id = $oOrder->getMeta('amazon_refund_id');
+
+?>
+
+<?php if (wpsg_isSizedString($amazon_refund_id)) { ?>
+
+	<?php echo wpsg_drawForm_Input(false, __('Refund ID', 'wpsg'), $amazon_refund_id, ['readonly' => true]); ?>
+
+<?php } else if (wpsg_isSizedString($amazon_capture_id)) { ?>
+
+	<?php echo wpsg_drawForm_Input(false, __('Capture ID', 'wpsg'), $amazon_capture_id, ['readonly' => true]); ?>
+
+<?php }
+
Index: /views/mods/mod_micropayment_paywindow/settings_edit.phtml
===================================================================
--- /views/mods/mod_micropayment_paywindow/settings_edit.phtml	(revision 7755)
+++ /views/mods/mod_micropayment_paywindow/settings_edit.phtml	(revision 7756)
@@ -14,5 +14,5 @@
 <?php echo wpsg_drawForm_Select('wpsg_mod_micropayment_paywindow_page_error', __('Fehlerseite', 'wpsg'), $view['arPages'], $this->get_option('wpsg_mod_micropayment_paywindow_page_error'), array('help' => 'wpsg_mod_micropayment_paywindow_page_error')); ?>
 <?php echo wpsg_drawForm_Input('wpsg_mod_micropayment_paywindow_paytitle', __('Titel der Zahlung', 'wpsg'), $this->get_option('wpsg_mod_micropayment_paywindow_paytitle'), ['placeholder' => $view['default_pay_title'], 'hint' => __('Maximal 150 Zeichen', 'wpsg')]); ?>
-<?php echo wpsg_drawForm_Input('wpsg_mod_micropayment_paywindow_paytext', __('Titel der Zahlung', 'wpsg'), $this->get_option('wpsg_mod_micropayment_paywindow_paytext'), ['placeholder' => $view['default_pay_text'], 'hint' => __('Maximal 250 Zeichen', 'wpsg')]); ?>
+<?php echo wpsg_drawForm_Input('wpsg_mod_micropayment_paywindow_paytext', __('Text der Zahlung', 'wpsg'), $this->get_option('wpsg_mod_micropayment_paywindow_paytext'), ['placeholder' => $view['default_pay_text'], 'hint' => __('Maximal 250 Zeichen', 'wpsg')]); ?>
 <?php echo wpsg_drawForm_Checkbox('wpsg_mod_micropayment_paywindow_sandbox', __('Testmodus', 'wpsg'), $this->get_option('wpsg_mod_micropayment_paywindow_sandbox')); ?>
 <?php echo wpsg_drawForm_Checkbox('wpsg_mod_micropayment_autorun', __('Zahlung sofort starten', 'wpsg'), $this->get_option('wpsg_mod_micropayment_autorun')); ?>
Index: /views/warenkorb/checkout2.phtml
===================================================================
--- /views/warenkorb/checkout2.phtml	(revision 7755)
+++ /views/warenkorb/checkout2.phtml	(revision 7756)
@@ -50,4 +50,6 @@
 		
 		</div>
+
+        <br /><br />
 						 
 		<?php if ($this->callMods('checkout_handlePayment') === true) { ?>
